/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */
package kai;

import java.applet.Applet;
import java.awt.BorderLayout;
import java.awt.Button;
import java.awt.Checkbox;
import java.awt.Color;
import java.awt.Event;
import java.awt.FlowLayout;
import java.awt.Font;
import java.awt.Graphics;
import java.awt.Image;
import java.awt.Panel;
import java.awt.TextField;
import java.util.Random;
import javax.swing.JOptionPane;

/**
 *
 * @author 08ekanay
 */
public class KaiApp extends Applet implements Runnable {

    int testrandomnumber = 0;

    int i, j, k;
    double SUM, mean, tmpdouble;
    int iteration = 0;
    int numacc = 0;
    int MAXNUMPARTS = 20;
    int MINNUMPARTS = 2;
    int NUMPARTS = 5;
    int PRAD = 10;
    int xmin = PRAD;
    int ymin = PRAD;
    int xmax;
    int ymax;
    int textwidth = 200;
    int textx;
    int texty = 30;
    int textinc = 30;
    int chosen = 1;
    int proprad = 50;
    //int xprop, yprop;
    double sumdif;
    double SCALE = 400.0;
    int A = 5;
    int B = 5;
    int C = 0;
    int parincr = 1;
    double sumdist, meandist;
    boolean REDRAW = true;
    boolean FORCEDREDRAW = true;
    int speedcontrol = 2;
    int MINNUMSTATES = 3;
    int MAXNUMSTATES = 10;
    double idens[] = new double[MAXNUMSTATES + 1];
    int denscount[] = new int[MAXNUMSTATES + 1];
    int xcoord[] = new int[MAXNUMPARTS + 1];
    int ycoord[] = new int[MAXNUMPARTS + 1];
    int xprop[] = new int[MAXNUMPARTS + 1];
    int yprop[] = new int[MAXNUMPARTS + 1];
    Random randgen = new Random();
    // Color panelcol = Color.gray;
    Color panelcol = new Color(178, 178, 178);
    int segment, itmp;
    boolean accept, JUMPONE, RECOUNT;
    boolean keyjustpressed = false;
    boolean RESTARTING = true;
    int ADAPTLEVEL = 1;
    Image holdImage;
    Graphics holdGraphics;
    Font strongfont = new Font("TimesRoman", Font.BOLD, 18);

    Checkbox bKai1 = new Checkbox("Target Acceptance");
    Checkbox bKai2 = new Checkbox("With Translation Algorithm");

    private double curaccrate;
    private double inputval;
    private boolean adaptationOn;
    private boolean translationOn;
    double transRand = Math.random();
    private int numtrans = 0;
    public void init() {
        this.setSize(800, 400);
        holdImage = createImage(size().width, size().height);
        holdGraphics = holdImage.getGraphics();
        xmax = size().width - textwidth - PRAD;
        ymax = size().height - PRAD;
        textx = xmax + 50;
        // repaint();
        this.setLayout(new BorderLayout() );
        Panel kaiP = new Panel(new BorderLayout());
        //Button bKai = new Button("Addaptation");
        kaiP.add(bKai1, BorderLayout.NORTH);
        kaiP.add(bKai2, BorderLayout.SOUTH);
        //TextField IKai = new TextField(6);
        //kaiP.add(IKai, BorderLayout.SOUTH);
        this.add(kaiP, BorderLayout.EAST);
        //JOptionPane.showInputDialog("gdfgdfg");

    }

    public void standardAlgo(){

// System.out.println("Here: xmin=" + xmin + ";   xmax=" + xmax);

            if (RESTARTING) {
                for (i = 1; i <= NUMPARTS; i++) {
                    xcoord[i] = xmin + randgen.nextInt(xmax - xmin + 1);
                    ycoord[i] = ymin + randgen.nextInt(ymax - ymin + 1);
                }
                zerocount();
                JUMPONE = RECOUNT = false;
                REDRAW = true;
                RESTARTING = false;
            } else if (RECOUNT) {
                zerocount();
                RECOUNT = false;
            }

// System.out.println("Here");

            // Start fresh iteration.

// System.out.println("Here");

            // Compute the proposal and accept/reject.
            chosen = 1 + randgen.nextInt(NUMPARTS);
            int xinc = randgen.nextInt(2 * proprad + 1) - proprad;
            int yinc = randgen.nextInt(2 * proprad + 1) - proprad;
            xprop[chosen] = xcoord[chosen] + xinc;
            yprop[chosen] = ycoord[chosen] + yinc;

            accept = false;

            if ((xprop[chosen] >= xmin) && (xprop[chosen] <= xmax)
                    && (yprop[chosen] >= ymin) && (yprop[chosen] <= ymax)) {

                sumdif = V(xprop[chosen], yprop[chosen]) - V(xcoord[chosen], ycoord[chosen]);
                for (i = 1; i <= NUMPARTS; i++) {
                    if (i != chosen) {
                        sumdif = sumdif + h(xcoord[i], ycoord[i], xprop[chosen], yprop[chosen])
                                - h(xcoord[i], ycoord[i], xcoord[chosen], ycoord[chosen]);
                    }
                }

                if (randgen.nextDouble() < Math.exp(-sumdif)) {
                    accept = true;
                }

            }

// System.out.println("Here");

            // Display the various segments of the iteration.
            for (segment = 1; segment <= 4; segment++) {
                updatenpause();
            }

// System.out.println("Here");

            // Update state.
            if (accept) {
                xcoord[chosen] = xprop[chosen];
                ycoord[chosen] = yprop[chosen];
                numacc++;
            }

            // Update functional values.
            sumdist = 0;
            for (i = 1; i < NUMPARTS; i++) {
                for (j = i + 1; j <= NUMPARTS; j++) {
                    sumdist = sumdist + dist(xcoord[i], ycoord[i], xcoord[j], ycoord[j]);
                }
            }
            meandist = sumdist / (NUMPARTS * (NUMPARTS - 1) / 2);
            SUM = SUM + meandist;
            iteration++;

            //calculating the current acceptance rate
            curaccrate = Math.round(10000.0 * numacc / iteration) / 100.0;

           
    }

    public void adaptation(){

                if (iteration % 1 == 0) {
                    double random = Math.random();
                    if (random < 1 / Math.log(iteration)) {
                        if (curaccrate < inputval) {
                            if (proprad > 1)
                                proprad--;
                        }else if (curaccrate > inputval){
                            proprad++;
                        }
                    }

                }

    }

    public void translationAlgo() {
        if (RESTARTING) {
            for (i = 1; i <= NUMPARTS; i++) {
                xcoord[i] = xmin + randgen.nextInt(xmax - xmin + 1);
                ycoord[i] = ymin + randgen.nextInt(ymax - ymin + 1);
            }
            zerocount();
            JUMPONE = RECOUNT = false;
            REDRAW = true;
            RESTARTING = false;
        } else if (RECOUNT) {
            zerocount();
            RECOUNT = false;
        }
        
        int xinc = randgen.nextInt(2 * proprad + 1) - proprad;
        int yinc = randgen.nextInt(2 * proprad + 1) - proprad;
        accept = true;
        for (int i = 1; i <= NUMPARTS; i++) {
            xprop[i] = xcoord[i] + xinc;
            yprop[i] = ycoord[i] + yinc;
            if (!((xprop[i] >= xmin) && (xprop[i] <= xmax)
                    && (yprop[i] >= ymin) && (yprop[i] <= ymax))) {
                accept = false;

            }
        }
//        for(int i=1; i<NUMPARTS; i++){
//            for (segment = 1; segment <= 4; segment++) {
//                updatenpause();
//            }
//        }
        for (segment = 1; segment <= 4; segment++) {
                updatenpause();
        }
        if (accept) {
            numacc++;
            
            for (int i = 1; i <= NUMPARTS; i++) {
                chosen = i;
                
                xcoord[i] = xcoord[i] + xinc;
                ycoord[i] = ycoord[i] + yinc;

                //System.out.println("Accepted xcoord of " + iteration + " " + xcoord[i]);

                
            }
            
        }
        sumdist = 0;
        for (int k = 1; k < NUMPARTS; k++) {
            for (j = k + 1; j <= NUMPARTS; j++) {
                sumdist = sumdist + dist(xcoord[k], ycoord[k], xcoord[j], ycoord[j]);
            }
        }
        meandist = sumdist / (NUMPARTS * (NUMPARTS - 1) / 2);
        SUM = SUM + meandist;


        curaccrate = Math.round(10000.0 * numacc / iteration) / 100.0;
        //System.out.println("Accepted numacc and iter of " + numacc + " " + iteration);
        iteration++;
    }

    public void run() {

        while (true) {
           if (translationOn) {
               transRand = Math.random();
               if (transRand < 0.5){
                this.translationAlgo();
                numtrans++;
                System.out.println("Numtrans: " + numtrans);
               }else{
                 this.standardAlgo();
                 //System.out.println("standard");
               }
            }else{
                this.standardAlgo();
            }
           if (adaptationOn){
                this.adaptation();
            }
        }
    }
    

    public void updatenpause() {

        if ((!RESTARTING) && (!RECOUNT)
                && ((speedcontrol < 5) || (segment == 1) || keyjustpressed)
                && ((segment < 5) || accept)) {

            itmp = 10 * (speedcontrol - 5) * (speedcontrol - 5);
            if ((speedcontrol <= 5) || keyjustpressed
                    || (iteration == (iteration / itmp) * itmp)) {
                repaint();
            }
            keyjustpressed = false;

            if (speedcontrol <= 1) {
                JUMPONE = false;
                while ((speedcontrol <= 1) && (JUMPONE == false)
                        && (!RESTARTING) && (!RECOUNT)) {
                    dosleep(50);
                }
            } else if (speedcontrol == 2) {
                dosleep(1000);
            } else if (speedcontrol == 3) {
                dosleep(250);
            } else if (speedcontrol == 4) {
                dosleep(50);
            } else if (speedcontrol == 5) {
                dosleep(40);
            } else if (speedcontrol >= 6) {
                dosleep(20);
            }

            REDRAW = FORCEDREDRAW;
            JUMPONE = false;

        }

    }

    public void paint(Graphics g) {

        if (REDRAW) {

            // setFont(strongfont);

            // Background rectangles.
            g.setColor(Color.pink);
            g.fillRect(0, 0, size().width - textwidth, size().height);
            g.setColor(panelcol);
            g.fillRect(size().width - textwidth, 0, textwidth, size().height);

        } // end of if(REDRAW)


        testrandomnumber++;
        // Text matter.
        g.setColor(Color.BLUE);
        g.drawString("Original algorithm and Code by Jeffrey S. Rosenthal",
                                                textx, texty + 14 * textinc);

        g.drawString("Translation Algorithm by Kai Yang "
                , textx, texty + 15 * textinc);
         g.drawString("Modified by " +
                "Chaveen Ekanayake and " +
                "Ahimsian Shanmugalingam", textx, texty + 16 * textinc);
        g.setColor(Color.black);
        g.drawString("Iterations: " + iteration, textx, texty + textinc);
       
        g.drawString("A = " + A, textx, texty + 2 * textinc);
        g.drawString("B = " + B, textx, texty + 3 * textinc);
        g.drawString("C = " + C, textx, texty + 4 * textinc);
        //g.drawString("accept = " + Math.round(10000.0 * numacc / iteration) / 100.0
               //        + "%", textx, texty + 5 * textinc);
        g.drawString("accept = " + curaccrate
                       + "%", textx, texty + 5 * textinc);
        g.drawString("# particles = " + NUMPARTS, textx, texty + 6 * textinc);
        g.drawString("speed = " + speedcontrol, textx, texty + 7 * textinc);
        g.drawString("curavdist = " + Math.round(1000.0 * meandist) / 1000.0,
                textx, texty + 10 * textinc);
        if (iteration > 0) {
            mean = SUM / ((double) iteration);
        } else {
            mean = 0.0;
        }
        g.drawString("meanavdist = " + Math.round(1000.0 * mean) / 1000.0,
                textx, texty + 11 * textinc);
        g.drawString("number of translations: "+ numtrans,
                textx, texty + 12 * textinc);
        
        // Draw current state.
        g.setColor(Color.black);
        for (i = 1; i <= NUMPARTS; i++) {
            fillcircle(g, xcoord[i], ycoord[i], PRAD);
        }

        if (segment >= 2) {

            // Draw chosen point.
            if (!(translationOn && transRand < 0.5)) {
                g.setColor(Color.white);
                fillcircle(g, xcoord[chosen], ycoord[chosen], PRAD);
            }
        }

        if (segment >= 3) {

            // Draw proposal dot.
            if (segment == 3) {
                g.setColor(Color.yellow);
            } else if (accept) {
                g.setColor(Color.green);
            } else {
                g.setColor(Color.red);
            }
            if (translationOn && transRand < 0.5){
                for (int i = 1; i <= NUMPARTS; i++) {
                    fillcircle(g, xprop[i], yprop[i], PRAD);
                }
            }else{
                 fillcircle(g, xprop[chosen], yprop[chosen], PRAD);
            }
        }

        


    }

    public void zerocount() {

        SUM = mean = 0.0;
        iteration = numacc = 0;

    }

    public double h(int x1, int y1, int x2, int y2) {
        double thedist = dist(x1, y1, x2, y2);
        return (1.0 * A * thedist + 0.04 * B / thedist);
    }

    public double V(int x1, int y1) {
        return (2.0 * C * x1 / SCALE);
    }

    public double dist(int x1, int y1, int x2, int y2) {
        return (Math.sqrt(sq((x2 - x1) / SCALE) + sq((y2 - y1) / SCALE)));
    }

    public double sq(double rr) {
        return (rr * rr);
    }

    public boolean action(Event e, Object o) {
        if (e.target.equals(bKai1)){
            if (bKai1.getState()) {
                String input = JOptionPane.showInputDialog("Input target " +
                        "acceptance rate e.g. 38.54");
                try {
                    if (input!= null){
                        inputval = Double.parseDouble(input);
                        adaptationOn = true;
                        
                    }
                } catch (NumberFormatException exp) {
                    JOptionPane.showMessageDialog(null, "Wrong input");
                }
            }else{
                adaptationOn = false;
                
            }
        }
        if (e.target.equals(bKai2)){
            if (bKai2.getState()){
               translationOn = true;

            }else{
                 translationOn = false;
            }
        }
        return true;
    }

    public void update(Graphics g) {
        paint(holdGraphics);
        g.drawImage(holdImage, 0, 0, this);
    }

    public void dosleep(long nummilisecs) {
        try {
            Thread.currentThread().sleep(nummilisecs);
        } catch (InterruptedException e) {
        }
    }

    public void fillcircle(Graphics g, int xx, int yy, int rr) {
        g.fillOval(xx - rr, yy - rr, 2 * rr, 2 * rr);
    }

    public boolean keyDown(Event evt, int key) {
        char keystroke = (char) key;

        if ((keystroke >= '0') && (keystroke <= '9')) {
            speedcontrol = keystroke - '0';
            if (keystroke > '0') {
                JUMPONE = true;
            }
        }

        if ((keystroke == 'r') || (keystroke == 'R')) {  // restart
            RESTARTING = true;
        }

        if ((keystroke == 'z') || (keystroke == 'Z')) {  // zero the counts
            zerocount();
        }

        if ((keystroke == '+') && (NUMPARTS < MAXNUMPARTS)) {
            // Increment the number of particles.
            NUMPARTS++;
            RESTARTING = true;
        }

        if ((keystroke == '-') && (NUMPARTS > MINNUMPARTS)) {
            // Decrement the number of particles.
            NUMPARTS--;
            RESTARTING = true;
        }

        if (keystroke == 'A') {
            A = A + parincr;
        }

        if (keystroke == 'a') {
            A = A - parincr;
        }

        if (keystroke == 'B') {
            B = B + parincr;
        }

        if (keystroke == 'b') {
            B = B - parincr;
        }

        if (keystroke == 'C') {
            C = C + parincr;
        }

        if (keystroke == 'c') {
            C = C - parincr;
        }

        keyjustpressed = true;
        repaint();
        return true;
    }
    Thread t;

    public void start() {
        t = new Thread(this);
        t.start();
    }

    public void stop() {
        t.stop();
        t = null;
    }
//TODO overwrite start(), stop() and destroy() methods
}
